---
title: WebGLRenderingContext.viewport()
slug: Web/API/WebGLRenderingContext/viewport
tags:
  - API
  - Method
  - Reference
  - WebGL
  - WebGLRenderingContext
---
<div>{{APIRef("WebGL")}}</div>

<p>The <strong><code>WebGLRenderingContext.viewport()</code></strong> method of the <a href="/en-US/docs/Web/API/WebGL_API">WebGL API</a> sets the viewport, which specifies the affine transformation of x and y from normalized device coordinates to window coordinates.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><var><em>void gl</em>.viewport</var><var>(x, y, width, height);</var>
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>x</code></dt>
 <dd>A {{domxref("GLint")}} specifying the horizontal coordinate for the lower left corner of the viewport origin. Default value: 0.</dd>
 <dt><code>y</code></dt>
 <dd>A {{domxref("GLint")}} specifying the vertical coordinate for the lower left corner of the viewport origin. Default value: 0.</dd>
 <dt>width</dt>
 <dd>A non-negative {{domxref("Glsizei")}} specifying the width of the viewport. Default value: width of the canvas.</dd>
 <dt>height</dt>
 <dd>A non-negative {{domxref("Glsizei")}} specifying the height of the viewport. Default value: height of the canvas.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>None.</p>

<h3 id="Errors_thrown">Errors thrown</h3>

<p>If either <em>width</em> or <em>height</em> is a negative value, a <code>gl.INVALID_VALUE</code> error is thrown.</p>

<h2 id="Examples">Examples</h2>

<p>When you first create a WebGL context, the size of the viewport will match the size of the canvas. However, if you resize the canvas, you will need to tell the WebGL context a new viewport setting. In this situation, you can use <code>gl.viewport</code>.</p>

<pre class="brush: js">gl.viewport(0, 0, canvas.width, canvas.height);
</pre>

<p>The viewport width and height are clamped to a range that is implementation dependent. To get this range, you can use the <code>MAX_VIEWPORT_DIMS</code> constant, which returns an {{jsxref("Int32Array")}}.</p>

<pre class="brush: js">gl.getParameter(gl.MAX_VIEWPORT_DIMS);
// e.g. Int32Array[16384, 16384]
</pre>

<p>To get the current viewport, query the <code>VIEWPORT</code> constant.</p>

<pre class="brush: js">gl.getParameter(gl.VIEWPORT);
// e.g. Int32Array[0, 0, 640, 480]
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebGL', "#5.14.4", "viewport")}}</td>
   <td>{{Spec2('WebGL')}}</td>
   <td>Initial definition.</td>
  </tr>
  <tr>
   <td>{{SpecName('OpenGL ES 2.0', "glViewport.xml", "glViewport")}}</td>
   <td>{{Spec2('OpenGL ES 2.0')}}</td>
   <td>Man page of the OpenGL API.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("api.WebGLRenderingContext.viewport")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("WebGLRenderingContext.scissor()")}}</li>
 <li>{{domxref("WebGLRenderingContext.getParameter()")}}</li>
</ul>
